import java.awt.geom.Point2D;

interface Damageable
{
	public void setHealth (int health);
	
	public int getHealth ();
	
	public void damage (int damage);
	
	public void die ();
}

abstract class DamageableEntity extends Entity implements Damageable
{
	protected int health = 25;
	
	DamageableEntity (Point2D.Double start, int inner)
	{
		super(start, inner);
	}	
	
	DamageableEntity (Point2D.Double start, int inner, int outer)
	{
		super(start, inner, outer);
	}	
	
	DamageableEntity (Point2D.Double start, int inner, int outer, int health)
	{
		super(start, inner, outer);
		
		setHealth(health);
	}
	
	public void setHealth (int health)
	{
		this.health = health;
	}
	
	public int getHealth ()
	{
		return health;
	}
	
	public void damage (int damage)
	{
		health -= damage;
		
		if (health <= 0)
		{
			die();
		}
	}
	
	public abstract void die ();
}
