import java.awt.*;
import java.awt.geom.Point2D;

class DeadBody extends Entity
{
	DeadBody (Point2D.Double p, Sprite sprite)
	{
		this(p, sprite, 0);
	}
	
	DeadBody (Point2D.Double p, Sprite sprite, int direction)
	{
		super(p, 0, 16, direction);
		
		sprite.setLimit(1);
		
		sprite.start();
		
		setSprite(sprite);
	}
	
	public void cycle ()
	{
		if (! getSprite().isRunning())
		{
			Image[] frames = getSprite().getFrames();
			
			Image levelImage = GameArea.getLevel().getImage();
			
			Graphics g = levelImage.getGraphics();
			
			if (! (g instanceof Graphics2D))
			{
				System.out.println("Oh dear.");
				return;
			}
			
			Graphics2D g2 = (Graphics2D) g;
			
			int x = leftEdge();
			int y = topEdge();
			
			g2.rotate(radians(direction), pos.x, pos.y);
				
			g2.drawImage(frames[frames.length-1], x, y, null);
			
			g2.rotate(- radians(direction), pos.x, pos.y);
			
			GameArea.getLevel().removeEntity(this);
		}
	}
}
