import java.awt.*;
import java.awt.geom.Point2D;

public class Explosion extends Entity
{
	int i = 0;
	int damage[] = new int[] {20, 15, 10, 5, 5, 5, 4, 3, 2};
	
	public Explosion (Point2D.Double p)
	{
		super(new Point2D.Double(p.x, p.y), 32);
		
		Sprite sprite = new Sprite(Store.getFrames("explosion"));
		
		sprite.setFrameTime(30);
		sprite.setLimit(1);
		
		setSprite(sprite);
		
		sprite.start();
		
		Store.getAudio("explosion").play();
	}
	
	public void cycle ()
	{
		if (getSprite().isRunning())
		{
			if (i < damage.length)
			{
				inner = 8 + 4 * i;
				
				for (Entity entity: GameArea.getLevel().entities)
				{
					if (entity instanceof Damageable)
					{
						if (touching(entity))
						{
							Damageable e = (Damageable) entity;
						
							e.damage(damage[i]);
						}
					}
				}
				
				i++;
			}
		}
		else
		{
			GameArea.getLevel().removeEntity(this);
		}
	}
}
